diff --git a/docs/bypass-iommu.txt b/docs/bypass-iommu.txt
index e6677bddd32..2ef0e0f6a65 100644
--- a/docs/bypass-iommu.txt
+++ b/docs/bypass-iommu.txt
@@ -51,7 +51,8 @@ And we got:
 x86 architecture:
 
 qemu-system-x86_64 \
- -machine q35,accel=kvm,default_bus_bypass_iommu=true \
+ -accel kvm \
+ -machine q35,default_bus_bypass_iommu=true \
  -device pxb-pcie,bus_nr=0x10,id=pci.10,bus=pcie.0,addr=0x3 \
  -device pxb-pcie,bus_nr=0x20,id=pci.20,bus=pcie.0,addr=0x4,bypass_iommu=true \
  -device intel-iommu \
diff --git a/docs/nvdimm.txt b/docs/nvdimm.txt
index fd7773dc5ab..d589c3a9b77 100644
--- a/docs/nvdimm.txt
+++ b/docs/nvdimm.txt
@@ -228,7 +228,7 @@ which allows the platform to communicate what features it supports related to
 NVDIMM data persistence.  Users can provide a persistence value to a guest via
 the optional "nvdimm-persistence" machine command line option:
 
-    -machine pc,accel=kvm,nvdimm,nvdimm-persistence=cpu
+    -machine pc,nvdimm,nvdimm-persistence=cpu
 
 There are currently two valid values for this option:
 
diff --git a/docs/specs/tpm.rst b/docs/specs/tpm.rst
index 1ad36ad7099..c50bb1cec01 100644
--- a/docs/specs/tpm.rst
+++ b/docs/specs/tpm.rst
@@ -329,7 +329,7 @@ In case a pSeries machine is emulated, use the following command line:
 
 .. code-block:: console
 
-  qemu-system-ppc64 -display sdl -machine pseries,accel=kvm \
+  qemu-system-ppc64 -display sdl -accel kvm -machine pseries \
     -m 1024 -bios slof.bin -boot menu=on \
     -nodefaults -device VGA -device pci-ohci -device usb-kbd \
     -chardev socket,id=chrtpm,path=/tmp/mytpm1/swtpm-sock \
diff --git a/docs/system/arm/cpu-features.rst b/docs/system/arm/cpu-features.rst
index a5fb929243c..4aed91a987d 100644
--- a/docs/system/arm/cpu-features.rst
+++ b/docs/system/arm/cpu-features.rst
@@ -329,7 +329,7 @@ SVE CPU Property Examples
   3) When KVM is enabled, implicitly enable all host CPU supported vector
      lengths with the ``host`` CPU type::
 
-     $ qemu-system-aarch64 -M virt,accel=kvm -cpu host
+     $ qemu-system-aarch64 -M virt -accel kvm -cpu host
 
   4) Only enable the 128-bit vector length::
 
diff --git a/docs/system/cpu-hotplug.rst b/docs/system/cpu-hotplug.rst
index cc50937c36c..64314ccfd6f 100644
--- a/docs/system/cpu-hotplug.rst
+++ b/docs/system/cpu-hotplug.rst
@@ -12,7 +12,7 @@ vCPU hotplug
     allow vCPU hotplug)::
 
       $ qemu-system-x86_64 -display none -no-user-config -m 2048 \
-          -nodefaults -monitor stdio -machine pc,accel=kvm,usb=off \
+          -nodefaults -monitor stdio -accel kvm -machine pc,usb=off \
           -smp 1,maxcpus=2 -cpu IvyBridge-IBRS \
           -qmp unix:/tmp/qmp-sock,server=on,wait=off
 
diff --git a/docs/system/ppc/powernv.rst b/docs/system/ppc/powernv.rst
index de7a807ac76..689f9c81a02 100644
--- a/docs/system/ppc/powernv.rst
+++ b/docs/system/ppc/powernv.rst
@@ -63,7 +63,7 @@ powernv. kvm-pr in theory could be used as a valid accel option but
 this isn't supported by kvm-pr at this moment.
 
 To spare users from dealing with not so informative errors when attempting
-to use accel=kvm, the powernv machine will throw an error informing that
+to use '-accel kvm', the powernv machine will throw an error informing that
 KVM is not supported. This can be revisited in the future if kvm-pr (or
 any other KVM alternative) is usable as KVM accel for this machine.
 
diff --git a/docs/system/ppc/pseries.rst b/docs/system/ppc/pseries.rst
index bbc51aa7fcd..3b18d2ee1ef 100644
--- a/docs/system/ppc/pseries.rst
+++ b/docs/system/ppc/pseries.rst
@@ -164,9 +164,9 @@ Currently, there are two implementations of KVM on Power, ``kvm_hv.ko`` and
 If a host supports both KVM modes, and both KVM kernel modules are loaded, it is
 possible to switch between the two modes with the ``kvm-type`` parameter:
 
-* Use ``qemu-system-ppc64 -M pseries,accel=kvm,kvm-type=PR`` to use the
+* Use ``qemu-system-ppc64 -accel kvm -M pseries,kvm-type=PR`` to use the
   ``kvm_pr.ko`` kernel module.
-* Use ``qemu-system-ppc64 -M pseries,accel=kvm,kvm-type=HV`` to use ``kvm_hv.ko``
+* Use ``qemu-system-ppc64 -accel kvm -M pseries,kvm-type=HV`` to use ``kvm_hv.ko``
   instead.
 
 KVM-PR
diff --git a/scripts/device-crash-test b/scripts/device-crash-test
index 2b139e29ba0..2c6fd7c6f6e 100755
--- a/scripts/device-crash-test
+++ b/scripts/device-crash-test
@@ -147,7 +147,7 @@ ERROR_RULE_LIST = [
     # "spapr-cpu-core needs a pseries machine"
     {'machine':'(?!pseries).*', 'device':'.*-spapr-cpu-core', 'expected':True},
 
-    # KVM-specific devices shouldn't be tried without accel=kvm:
+    # KVM-specific devices shouldn't be tried without '-accel kvm':
     {'accel':'(?!kvm).*', 'device':'kvmclock', 'expected':True},
 
     # xen-specific machines and devices: